include variables.inc

pixel_offset struct
xorigin	word ?
yorigin	word ?
x	word ?
y	word ?
pixel_offset ends

.code


PrepareParse proc pszfile

	invoke CreateFile,pszfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov hFiles,eax
	invoke ReadFile,hFiles,addr bf,sizeof bf,addr rdbytes,0
	invoke ReadFile,hFiles,addr bi,sizeof bi,addr rdbytes,0
	
	push bi.biWidth
	push bi.biHeight
	add bi.biWidth,6				;borderwidth == 3 & 3
	add bi.biHeight,44				;borderwidth == 4(bottom) & 40(top)
	invoke GetSystemMetrics,SM_CXSCREEN
	invoke CenterWnd,bi.biWidth,eax
	mov ebx,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	invoke CenterWnd,bi.biHeight,eax	
	invoke SetWindowPos,hwnd,HWND_TOP,ebx,eax,bi.biWidth,bi.biHeight,SWP_SHOWWINDOW 
	pop bi.biHeight
	pop bi.biWidth

;--------calculate the bmpWidth&spw&bmpsize-----------
	
	mov eax,bi.biWidth
	mov ecx,3
	mul ecx  
	mov bmpWidth,eax	

	mov eax,bf.bfSize
	sub eax,54
	mov bmpsize,eax
	
	mov ecx,bi.biHeight
	div ecx
	mov spw,eax
;---------------------------------------------

;--------allocate heap for Pixel_Offset array--
	mov eax,bi.biWidth
	mul bi.biHeight
	mov ecx,8
	mul ecx
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
	mov pPO,eax
	invoke InitiPo

	
;---------------------------------------------

	mov eax,bmpsize
	sub eax,bmpsize2
	jna  @f
	.if !pHeap
		invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bmpsize
		mov pHeap,eax
		
	.else
		invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,pHeap,bmpsize
		mov pHeap,eax 
	.endif
	
	push bmpsize
	pop bmpsize2
	@@:
	invoke ReadFile,hFiles,pHeap,bmpsize,addr rdbytes,0
	invoke CloseHandle,hFiles
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bmpsize
	mov pHeap2,eax
	
	mov esi,pHeap
	mov edi,pHeap2
	mov ecx,bmpsize
	.while ecx > 0
		mov eax,[esi]
		mov [edi],eax
		sub ecx,4
		add esi,4
		add edi,4
	.endw

	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bmpsize
	mov pHeap3,eax

	ret
PrepareParse endp

GrayScale proc
	mov esi,pHeap2
	mov ecx,bi.biHeight
	.while ecx > 0
		push ecx
		
		mov ecx,bmpWidth
		push esi
		.while ecx > 0
			
			movzx ax, BYTE PTR [esi]
			mul bBalance
			div wDivisor
			xchg bl,al
			
			movzx ax, BYTE PTR [esi+1]
			mul gBalance
			div wDivisor
			add bl,al
			
			movzx ax, BYTE PTR [esi+2]
			mul rBalance
			div wDivisor
			add bl,al
			
			mov [esi],bl
			mov [esi+1],bl
			mov [esi+2],bl
				
			add esi,3
			sub ecx,3
		.endw
		pop esi
		add esi,spw
		pop ecx
		dec ecx
	.endw
	invoke LoadBmp
	ret
GrayScale endp

FlipHoriz proc
	mov esi,pHeap2
	mov edi,pHeap3
	mov ecx,bi.biHeight
	.while ecx > 0
		push ecx
		mov ecx,bmpWidth
		push esi
		.while ecx > 0
			
			mov al,[esi]
			mov [edi+ecx-3],al
			mov al,[esi+1]
			mov [edi+ecx-2],al
			mov al,[esi+2]			
			mov [edi+ecx-1],al			
			add esi,3
			sub ecx,3
		.endw
		pop esi
		add esi,spw
		add edi,spw
		pop ecx
		dec ecx

	.endw

	mov esi,pHeap3
	mov edi,pHeap2
	mov ecx,bmpsize
	.while ecx > 0
		mov eax,[esi]
		mov [edi],eax
		add esi,4
		add edi,4
		sub ecx,4
	.endw
	invoke LoadBmp
	ret
FlipHoriz endp

FlipVerti proc
	mov esi,pHeap2
	mov edi,pHeap3
	mov ecx,bi.biHeight

	.while ecx > 0
		mov eax,ecx
		dec eax
		mul spw
		mov ebx,eax
		push ecx
		mov edi,pHeap3
		mov ecx,bmpWidth
		push esi
		.while ecx > 0
			
			mov al,[esi]
			mov [edi+ebx],al
			mov al,[esi+1]
			mov [edi+ebx+1],al
			mov al,[esi+2]			
			mov [edi+ebx+2],al			
			add esi,3
			add edi,3
			sub ecx,3
		.endw
		pop esi
		add esi,spw
		pop ecx
		dec ecx
	.endw

	mov esi,pHeap3
	mov edi,pHeap2
	mov ecx,bmpsize
	.while ecx > 0
		mov eax,[esi]
		mov [edi],eax
		add esi,4
		add edi,4
		sub ecx,4
	.endw
	invoke LoadBmp
	ret
FlipVerti endp

Invert proc
	mov edi,pHeap2
	mov ecx,bi.biHeight
	.while ecx > 0
		push ecx		
		push edi
		mov ecx,bmpWidth
		.while ecx > 0
			mov al,[edi]
			mov bl,0ffh
			sub bl,al
			mov [edi],bl
			inc edi
			dec ecx
		.endw
		pop edi	
		add edi,spw
		pop ecx
		dec ecx
	.endw
	
	invoke LoadBmp
	
	ret
Invert endp

SaveBmp proc
	invoke MessageBox,hwnd,addr strSave,addr AppName,MB_YESNO
	.if eax == IDYES
		mov  ofn.lpstrTitle,offset SaveTitle
		mov  ofn.lpstrDefExt,offset strFilter
		invoke GetSaveFileName,addr ofn
		invoke CreateFile,ofn.lpstrFile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_DELETE or FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		mov hFiled,eax
		invoke WriteFile,hFiled,addr bf,sizeof bf,addr rdbytes,0
		invoke WriteFile,hFiled,addr bi,sizeof bi,addr rdbytes,0
		invoke WriteFile,hFiled,pHeap2,bmpsize,addr rdbytes,0
		invoke CloseHandle,hFiled
		
	.endif

	ret
SaveBmp endp

